#ifndef CALENDARVIEWSPREF_H
#define CALENDARVIEWSPREF_H
/********************************************************/
/* Vue de la fenetre des parametres du NetCountCalendar */
/********************************************************/

#include <View.h>
#include <ListView.h>
#include <Button.h>
#include <CheckBox.h>
#include <Box.h>
#include <ColorControl.h>
#include <TextControl.h>
#include <TextView.h>
#include "CNumberScroll.h"
#include "Counter.h"
#include "NetCountCalendar.h"

/*** Colors constant ***/
const	rgb_color	UC_BLACK	= {0,0,0,255};	

/**** FixedPrice settings ****/
class FixedPriceViewPref : public BView
{
protected:
	BCheckBox		*_useFixedPrice;
	BBox			*_fixedPriceBox;
	BButton			*_updateButton;
	BTextControl	*_definitionText;
	BTextControl	*_priceText;	
	BTextControl	*_timeText;	
	BTextControl	*_pricePlusText;	
	BTextView		*_infohours;
	BCheckBox		*_useCalendar;
	BCheckBox		*_chooseSartType;
	BTextControl	*_startDayText;
	CNumberScroll	*_startDay;
	BCheckBox		*_countEntireMinute;
	BString			_tempString;
	// pour l'acces au variable d el'application
	CounterApp		*_app;
	
public:
	FixedPriceViewPref(BRect ,const char *);
	virtual ~FixedPriceViewPref(void);
	virtual void MessageReceived(BMessage *msg);
	virtual void AttachedToWindow();

private:
	void	SetStateFixedPrice();
	void	FillWithDatas();
	void	UpdateValues();
};

/**** connection cost settings ****/
class ConnectionCostViewPref : public BView
{
protected:
	BCheckBox		*_useCostConnection;
	BBox			*_costBox;
	BButton			*_updateButton;
	BTextControl	*_definitionText;
	BTextControl	*_priceText;	
	BTextControl	*_timeText;	
	// pour l'acces au variable d el'application
	CounterApp		*_app;

public:
	ConnectionCostViewPref(BRect ,const char *);
	virtual ~ConnectionCostViewPref(void);
	virtual void MessageReceived(BMessage *msg);
	virtual void AttachedToWindow();

private:
	void	SetStateCostConnection();
	void	FillWithDatas();
	void	UpdateValues();
		
};

/**** connections settings ****/
class ConnectionListViewPref : public BView
{
protected:
	BListView		*_prefListView;
	BButton			*_addButton;
	BButton			*_removeButton;
	BButton			*_modifyButton;
	BColorControl	*_fixColorItem;
	BTextControl	*_definitionText;
	BTextControl	*_priceText;	
	// pour l'acces au variable d el'application
	CounterApp		*_app;

public:
	ConnectionListViewPref(BRect ,const char *);
	virtual ~ConnectionListViewPref(void);
	virtual void Draw(BRect frame);
	virtual void MessageReceived(BMessage *msg);
	virtual void AttachedToWindow();

	void	LoadListValues();
	void 	FillInfoItems();	
	void	AddAnItem();
	void	RemoveAnItem();
	void	ModifyAnItem();
};

/**** connections settings ****/
class BlankListViewPref : public BView
{
protected:
	BRect			_colorChoice;
	BListView		*_blankListView;
	BButton			*_addButton;
	BButton			*_removeButton;
	BButton			*_modifyButton;
	BTextControl	*_dayText;
	CNumberScroll	*_dayScroll;
	BTextControl	*_monthText;
	CNumberScroll	*_monthScroll;
	BTextControl	*_nameBlank;
	rgb_color		_colorBlank;
	int32			_indexBlank;
	BPopUpMenu		 *_popupprices;
	// pour l'acces au variable d el'application
	CounterApp		*_app;

public:
	BlankListViewPref(BRect ,const char *);
	virtual ~BlankListViewPref(void);
	virtual void Draw(BRect frame);
	virtual void MessageReceived(BMessage *msg);
	virtual void AttachedToWindow();
	virtual void MouseDown(BPoint Point);

	void	LoadListValues();
	void 	FillInfoItems();	
	void	AddAnItem();
	void	RemoveAnItem();
	void	ModifyAnItem();
	void	BuildMenu();
};

#endif