/*
	
	HelloWindow.h
	
	Copyright 1997 Be Incorporated, All Rights Reserved.
	
*/

#ifndef COUNTER_WINDOW_H
#define COUNTER_WINDOW_H

#include <Window.h>
#include "CounterView.h"

class CounterApp;
class CMenuBarIcon;

// consants for messages
const	uint32 U_ABOUT				= 'Uabt';
const	uint32 U_VIEW_CONNECTIONS	= 'Ucon';
const	uint32 U_FIX_PRICE			= 'Upri';
const	uint32 U_APP_SETTINGS		= 'Uase';

class CounterWindow : public BWindow 
{
protected:
	BWindow			*_historyWindow;
	BWindow			*_fixPriceWindow;
	BWindow			*_aboutWindow;
	BWindow			*_settingWindow;
	CMenuBarIcon	*_menuBar;
	CounterView		*_aView;
	// for access to app
	CounterApp		*_app;

public:
	CounterWindow(BRect frame); 
	virtual	bool	QuitRequested();
	virtual	void	MessageReceived(BMessage *message);
	void			OpenHistoryWindow();
	void			OpenTariffWindow();
	void			OpenAboutWindow();
	void			OpenSettingsWindow();
	BRect			FrameWinSetting();

	inline	BView*	counterView()		{ return _aView; }

private:
	void	BuildMenuBar();
};

#endif //COUNTER_WINDOW_H
