/**********************************/
/* View for the deskbar Replicant */
/**********************************/

#ifndef _REPLICANT_COUNTER_H
#define _REPLICANT_COUNTER_H


#include <time.h>
#include <View.h>
#include <String.h>
#include <Bitmap.h>
#include <PopUpMenu.h>
#include "BubbleHelper.h"

// Messages for replicant
const	uint32	R_UPDATE_TOTAL_TIME_MSG		= 'Rutt'; 
const	uint32	R_PULSE_DEFINE_MSG			= 'Rpdm';
const	uint32	R_WINDOW_REQUESTED_MSG		= 'Rswm';
const	uint32	R_ABOUT_REQUESTED_MSG		= 'Rarm';
const	uint32	R_START_CONNECTION_MSG		= 'Rscm';
const	uint32	R_END_CONNECTION_MSG		= 'Recm';
const	uint32	R_TOTAL_DURING_TIME_MSG		= 'Rtdm';
const	uint32	R_REMOVE_REPLICANT_MSG		= 'Rrrm';
const	uint32	R_BUILD_MENU_MSG			= 'Rbmm';
const	uint32	R_CONNECT_TO_APP_MSG		= 'Rcta';

class ReplicantCounter : public BView 
{	
protected:
	bool			_connected;
	int32			_duringtime;
	int32			_totaltime;
	tm				_starttime;
	BMessenger		_messenger;
	BBitmap			*_heure;
	int32			*_valueDisplay;
	BPopUpMenu		*_popup;
	BubbleHelper	*_helpTime;
	BString			_totalTime;
	BString			_duringTime;
	bool			_connectToApp;
	
public:
	ReplicantCounter(BRect , const char *); 
	ReplicantCounter(BMessage *);
	virtual ~ReplicantCounter();
	
	// for archiving view in deskbar
	static ReplicantCounter *Instantiate(BMessage *data);
	virtual	status_t Archive(BMessage *data, bool deep = true) const;

	virtual void	AttachedToWindow(void);
	virtual void	DetachedFromWindow(void);
	virtual void 	MessageReceived(BMessage *message);
	virtual void	MouseDown(BPoint point);
	virtual void	Draw(BRect updateRect);
	virtual void	Pulse();

private:
	void	InitDatas();
	void	ChooseDisplayTime();
	void	UpdateBubbleHelp();
	void	StartConnection(BMessage *);
	void	EndConnection();
	void	BuildMenu(BMessage *);
	void	ConnectToApp();
};

#endif _REPLICANT_COUNTER_H
