/***************************************************************/
/* The class CMenuBarIcon is an extention of class BMenuBar    */
/* It's for graphical application, you can see a icon on right */
/* of menu                                                     */
/***************************************************************/

#include <Bitmap.h>
#include "CMenuBarIcon.h"
#include "Counter.h"

CMenuBarIcon::CMenuBarIcon(BRect frame,const char *name,uint32 resizeMask,menu_layout layout,bool resizeToFit)
: BMenuBar(frame,name,resizeMask,layout,resizeToFit)
{
	size_t	taille;
	const void	*image;

	SetFontSize(12.0);

	_connected = new BBitmap(BRect(0,0,18,17),B_CMAP8);
	image = ((CounterApp *)be_app)->resApp.LoadResource('BBMP',"CONECTED_BTMP",&taille);
	_connected->SetBits((char *)image+146,684,0,B_CMAP8);

	_transfert = new BBitmap(BRect(0,0,18,17),B_CMAP8);
	image = ((CounterApp *)be_app)->resApp.LoadResource('BBMP',"TRANSFERT_BTMP",&taille);
	_transfert->SetBits((char *)image+146,684,0,B_CMAP8);

	_unconnected = new BBitmap(BRect(0,0,18,17),B_CMAP8);
	image = ((CounterApp *)be_app)->resApp.LoadResource('BBMP',"DECONNECTED_BTMP",&taille);
	_unconnected->SetBits((char *)image+146,684,0,B_CMAP8);

	_bitmapDraw = _unconnected;
}

CMenuBarIcon::~CMenuBarIcon()
{
	delete _connected;
	delete _transfert;
	delete _unconnected;
}

void CMenuBarIcon::Draw(BRect frame)
{
	BRect bounds = Bounds();
	
	BMenuBar::Draw(frame);
	
	DrawBitmap(_bitmapDraw,BPoint(bounds.right-19,0));	
}

/**** Message received ****/
void CMenuBarIcon::MessageReceived(BMessage *msg)
{

	BRect	refresh(Bounds().right-19,0,Bounds().right,18);
	
	switch(msg->what)
	{
		/*** switch the bitmap ***/
		case PPP_UNCONNECT_MSG:
			_bitmapDraw = _unconnected;
			Invalidate(refresh);
			break;
		case PPP_CONNECT_MSG:
			_bitmapDraw = _connected;
			Invalidate(refresh);
			break;
		case PPP_TRANSMIT_MSG:
			_bitmapDraw = _transfert;
			Invalidate(refresh);
			break;
		default:
			BMenuBar::MessageReceived(msg);
	}
}