#include <assert.h>
#include <Application.h>
#include <FindDirectory.h>
#include <Path.h>
#include <String.h>
#include <Window.h>
#include <File.h>
#include "Preferences.h"

#include <stdio.h>

extern BApplication *be_app;

CPreferences::CPreferences(const char *fileName, const char *filePath)
{
	BFile		file;
	BPath		path;
	BString		prefsFilePath;
	
	if((_status=find_directory(B_USER_SETTINGS_DIRECTORY,&path))!=B_OK)
		return;

	prefsFilePath=path.Path();
	if(filePath!=NULL)
	{
		if(filePath[0]!='/')
			prefsFilePath.Append("/");
		prefsFilePath.Append(filePath);
	}
	if(prefsFilePath.ByteAt(prefsFilePath.Length())!='/')
		prefsFilePath.Append("/");
	prefsFilePath.Append(fileName);

	_filePath=new char[prefsFilePath.Length()+1];
	strcpy(_filePath,prefsFilePath.String());

	if((_status=file.SetTo(_filePath,B_READ_ONLY))!=B_OK)
		return;
	if((_status=BMessage::Unflatten(&file))!=B_OK)
		return;
}

CPreferences::~CPreferences()
{
	BFile		file;
	status_t	status;

	if((status=file.SetTo(_filePath,B_CREATE_FILE|B_ERASE_FILE|B_WRITE_ONLY))!=B_OK)
		return;
	
	if((status=BMessage::Flatten(&file))!=B_OK)
		return;

	delete [] _filePath;
}

status_t CPreferences::Add(const char *name, BMessage *msg)
{
	status_t	status;
	
	if(BMessage::HasMessage(name))
		status=BMessage::ReplaceMessage(name,msg);
	else
		status=BMessage::AddMessage(name,msg);

	return status;
}

status_t CPreferences::Get(const char *name, BMessage *msg)
{
	return BMessage::FindMessage(name,msg);
}

status_t CPreferences::PreferencesLoaded()
{
	return _status;
}

const char	*CPreferences::SettingPath()
{
	return	_filePath;
}
